// butt - broadcast using this tool
//
// Copyright 2007 by Daniel Noethen.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//


#define ALSA_PCM_NEW_HW_PARAMS_API

#include <stdio.h>
#include <stdlib.h>

#include <lame/lame.h>
#include <alsa/asoundlib.h>
#include <signal.h>
#include <FL/fl_ask.H>

#include "butt.h"

#include "flgui.h"
#include "alsa.h"
#include "encode.h"
#include "network.h"

#include "parseconfig.h"




config_t cfg;
flgui *fl_g = new flgui();
int display_info = TIME;
char *cfg_path;

int main()
{
	
    char lcd_buf[33];
    char info_buf[256];
			
    signal(SIGPIPE, SIG_IGN); //ignore the SIGPIPE signal. 
							   //(in case the server closes the connection unexpected)
                               
                               
    memset(&cfg, 0, sizeof(config_t));    
				
	
	fl_g->window_main->show();  //show the gui window
  
       
    cfg_path = (char*)malloc(PATH_MAX+strlen(CONFIG_FILE)+1);
    
	cfg_path = getenv("HOME");	
	cfg_path = strcat(cfg_path, CONFIG_FILE);
		 
	
	if(cfg_set_values())		//read configfile and set the vars		
	{
	    if(cfg_create_default())
        {
            fl_alert("Could not create config file (%s)", cfg_path);
            return 1;
        }
        sprintf(info_buf, "butt created a default config file:\n(%s)\n"
                            "click on the red button right to the LCD\n"
                            "to add a server\n",
                            cfg_path
                            );
        fl_g->print_info(info_buf, 0);        
        
        cfg_set_values();        		
	}    

	
	if(!snd_init())
		fl_g->print_info("alsa init succeeded", 0);
	else
	{
            fl_alert("ALSA init failed");
            return 1;						
		
	}
    
	if(!encode_init())	
		fl_g->print_info("lame init succeeded\n"
						  "------------------------\n", 0);
	else
	{
		
        fl_alert("LAME init failed");
        
	}
	
		
	sprintf(lcd_buf, "status: idle");
    fl_g->lcd->print((const uchar*)lcd_buf, strlen(lcd_buf));
	fl_g->lcd->cursor_pos(0);
	
	snd_loop(); //this is the main loop    
	
	return 0;
}
