// network stuff for butt
//
// Copyright 2007 by Daniel Noethen.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "butt.h"
#include "network.h"
#include "parseconfig.h"
#include "flgui.h"

struct hostent *host_ptr;
struct sockaddr_in hostname;

int network_s;	

unsigned int network_bytes_sent;

int network_conn()
{	
	
	int rc;
	char recv_buf[100];
	
	network_s = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (network_s == -1)
    {
        
					
		fl_g->print_info("\ncould not create network socket", 1);
		               
		close(network_s);
		return 2;   		
		
    }
	 
	host_ptr = gethostbyname(cfg.srv[cfg.selected_srv]->addr);
    if (host_ptr == NULL)
    {
        host_ptr = gethostbyaddr(cfg.srv[cfg.selected_srv]->addr, strlen(cfg.srv[cfg.selected_srv]->addr), AF_INET);
		
		if (host_ptr == NULL)
        {		
			
			fl_g->print_info("\nerror resolving server address", 1);
			
			close(network_s);
			return 2;
			
        }
    }
		
	hostname.sin_family = AF_INET;
    hostname.sin_port = htons(cfg.srv[cfg.selected_srv]->port+1);
    
	memcpy(&hostname.sin_addr, host_ptr->h_addr,	host_ptr->h_length);

    rc = connect(network_s, (struct sockaddr*) &hostname, sizeof(hostname));
	
    if (rc == -1)  
    {
		close(network_s);
		return 1;
	}
   
	
	
	write(network_s, cfg.srv[cfg.selected_srv]->pwd, strlen(cfg.srv[cfg.selected_srv]->pwd));
	write(network_s, "\n", 1);


	rc = read(network_s, recv_buf, sizeof(recv_buf)-1);
	if( (recv_buf[0] != 'O') || (recv_buf[1] != 'K') || (rc <= 2) )
	{
		
		if(strstr(recv_buf, "invalid") != NULL)
		{
			fl_g->print_info("\ninvalid password!", 0);
			close(network_s);
			return 2;
		}
			
		return 1;
	}

	
	write(network_s, "icy-name:", 9);	
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->desc != NULL)
		    write(network_s, cfg.icy[cfg.selected_icy]->desc, strlen(cfg.icy[cfg.selected_icy]->desc));
	write(network_s, "\n", 1);
	
	write(network_s, "icy-genre:", 10);
	if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->genre != NULL)
		    write(network_s, cfg.icy[cfg.selected_icy]->genre, strlen(cfg.icy[cfg.selected_icy]->genre));
	write(network_s, "\n", 1);
		
	write(network_s, "icy-url:", 8);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->url != NULL)
		write(network_s, cfg.icy[cfg.selected_icy]->url, strlen(cfg.icy[cfg.selected_icy]->url));
	write(network_s, "\n", 1);
	
	write(network_s, "icy-irc:", 8);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->irc != NULL)
		    write(network_s, cfg.icy[cfg.selected_icy]->irc, strlen(cfg.icy[cfg.selected_icy]->irc));
	write(network_s, "\n", 1);
	
	write(network_s, "icy-icq:", 8);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->icq != NULL)
		    write(network_s, cfg.icy[cfg.selected_icy]->icq, strlen(cfg.icy[cfg.selected_icy]->icq));
	write(network_s, "\n", 1);
	
	write(network_s, "icy-aim:", 8);
    if(cfg.main.num_of_icy > 0)	
        if(cfg.icy[cfg.selected_icy]->aim != NULL)
		    write(network_s, cfg.icy[cfg.selected_icy]->aim, strlen(cfg.icy[cfg.selected_icy]->aim));	
	write(network_s, "\n", 1);
	
	write(network_s, "icy-pub:", 8);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->pub != NULL)	
		    write(network_s, cfg.icy[cfg.selected_icy]->pub, strlen(cfg.icy[cfg.selected_icy]->pub));
	write(network_s, "\n", 1);
	
	write(network_s, "icy-br:", 7);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->br != NULL)
		    write(network_s, cfg.icy[cfg.selected_icy]->br, strlen(cfg.icy[cfg.selected_icy]->br));	
	write(network_s, "\n", 1);
	
	write(network_s, "content-type:", 13);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->type != NULL)
		    write(network_s, cfg.icy[cfg.selected_icy]->type, strlen(cfg.icy[cfg.selected_icy]->type));
	write(network_s, "\n\n", 2);
	
	return 0;	
	
}
/* //inline function - look at the header file

int network_send(char *buf, int buf_len)
{
		
	return write(network_s, buf, buf_len);
	
}*/

